#ifndef RATIONAL_H
#define RATIONAL_H
#include <fstream>

class Rational
{
public:
	Rational();
	Rational(const Rational& original);
	~Rational();
	Rational& operator=(const Rational& rhs);
	Rational(long int nm, long int dn=1);
	// Sends object to the output stream
	void insert(std::ostream& os) const;
	// Extracts a rational number from the input stream
	void extract(std::istream& is);
	// Math operators
	Rational operator+(const Rational& rhs) const;
	Rational operator-(const Rational& rhs) const;
	Rational operator/(const Rational& rhs) const;
	Rational operator*(const Rational& rhs) const;
	// Comparison operators
	bool operator<(const Rational& rhs) const;
	bool operator<=(const Rational& rhs) const;
	bool operator==(const Rational& rhs) const;
	bool operator!=(const Rational& rhs) const;
	bool operator>(const Rational& rhs) const;
	bool operator>=(const Rational& rhs) const;
	// returns value of the calling object as a double
	double export() const;
	const Rational& operator+=(const Rational& rhs);

private:
	// Puts object in reduced form
	void reduce();
	long int num;
	long unsigned int den;
};

std::ostream& operator<<(std::ostream& os, const Rational& rtnl);
std::istream& operator>>(std::istream& is, Rational& rtnl);

#endif
